###############################################################################
#    Instructions to Make, for compilation of ISODE processes for 
#                                                             Olivetti LSX 30xx
###############################################################################

###############################################################################
#
# $Header: /f/osi/config/RCS/osx.make,v 7.1 90/03/06 13:56:05 mrose Exp $
#
#
# $Log:	osx.make,v $
# Revision 7.1  90/03/06  13:56:05  mrose
# touch-up
# 
# Revision 7.0  89/11/23  21:26:14  mrose
# Release 6.0
# 
###############################################################################

###############################################################################
#
#				 NOTICE
#
#    Acquisition, use, and distribution of this module and related
#    materials are subject to the restrictions of a license agreement.
#    Consult the Preface in the User's Manual for the full terms of
#    this agreement.
#
###############################################################################


###############################################################################
# Options
###############################################################################

# Set where to find the file asn1.h ros.h etc
ROSINC=		/usr3/thorn3/src/ASN1 \
		-I/usr3/thorn3/src/ROS \
		-I/usr3/thorn3/src/ISO 


OPTIONS	=	-I$(TOPDIR)h -DDEBUG -I/usr/include/netinet $(PEPYPATH)
THORN	=	/usr1/thorn/Y3/src/thorn/TEST/

HDIR    =       $(TOPDIR)h/
UTILDIR =       $(TOPDIR)util/
BINDIR  =       $(THORN)bin/
SBINDIR  =       $(THORN)etc/
ETCDIR  =       $(THORN)etc/
INCDIRM =       $(THORN)src/include/isode
INCDIR  =       $(INCDIRM)/
PEPYDIRM=       $(INCDIR)pepy
PEPYDIR =       $(PEPYDIRM)/
LIBDIR  =       $(THORN)src/lib/
LINTDIR =       $(THORN)src/lib/

SYSTEM  =       -sys5
MANOPTS =       -sys5


###############################################################################
# Programs and Libraries
###############################################################################

MAKE    =       ./make DESTDIR=$(DESTDIR) $(MFLAGS) -k
SHELL   =       /bin/sh

CC      =       cc
CFLAGS  =       -g    $(OPTIONS)
LINT    =       lint
LFLAGS  =       -bhuz $(OPTIONS)
LD      =       ld
LDCC    =       $(CC)
LDFLAGS =       -s
ARFLAGS =
LN      =       ln

# Olivetti TCP/IP software is put in libc!
LSOCKET	=	-lc


###############################################################################
# Generation Rules for library modules
###############################################################################

.c.o:;          $(CC) $(CFLAGS) -c $*.c
		-ld -x -r $@
		mv a.out $@
